module board;

import <cstdint>;
import <iostream>;
import <vector>;
import <tuple>;

board::board() {
	this->cells[0][0] = 1;
	this->x           = 0;
	this->y           = 0;
}

void board::move(uint8_t x, uint8_t y) {
	this->x = x;
	this->y = y;
	this->cells[x][y] = 1;
}

std::vector<std::tuple<uint8_t, uint8_t>> board::cell_moves(uint8_t x, uint8_t y) {
	std::vector<std::tuple<uint8_t, uint8_t>> moves = {};

	if (x >= 1 && y >= 2 && !this->cells[x-1][y-2]) moves.push_back({ x - 1, y - 2 });
	if (x >= 1 && y <= 5 && !this->cells[x-1][y+2]) moves.push_back({ x - 1, y + 2 });
	if (x >= 2 && y >= 1 && !this->cells[x-2][y-1]) moves.push_back({ x - 2, y - 1 });
	if (x >= 2 && y <= 6 && !this->cells[x-2][y+1]) moves.push_back({ x - 2, y + 1 });
	if (x <= 5 && y >= 1 && !this->cells[x+2][y-1]) moves.push_back({ x + 2, y - 1 });
	if (x <= 5 && y <= 6 && !this->cells[x+2][y+1]) moves.push_back({ x + 2, y + 1 });
	if (x <= 6 && y >= 2 && !this->cells[x+1][y-2]) moves.push_back({ x + 1, y - 2 });
	if (x <= 6 && y <= 5 && !this->cells[x+1][y+2]) moves.push_back({ x + 1, y + 2 });

	return moves;
}

void board::print_board() {
	for (uint8_t i = 0; i < 8; i++) {
		for (uint8_t j = 0; j < 8; j++) {
			if (this->x == i && this->y == j) {
				std::cout << 'o';
			} else if (this->cells[i][j]) {
				std::cout << 'x';
			} else {
				std::cout << ' ';
			}	
		}
		
		std::cout << '\n';
	}
}
