import <iostream>;
import <vector>;
import <tuple>;

import board;

int main (int argc, char* argv[]) {
	std::vector<std::tuple<uint8_t, uint8_t>> history = {{ 0, 0 }};

	board b;

	while (1) {
		auto moves = b.cell_moves(b.x, b.y);

		if (moves.size() == 0) break;

		uint8_t tm = 255;
		uint8_t tx = 0;
		uint8_t ty = 0;

		for (auto [nx, ny] : moves) {
			uint8_t nm = b.cell_moves(nx, ny).size();
			if (nm > tm) continue;
			tm = nm; tx = nx; ty = ny;
		}

		b.move(tx, ty);
		history.push_back({ tx, ty });
	}

	std::cout << "<!--\n";
	b.print_board();
	std::cout << "-->\n";

	std::cout << "<svg viewBox=\"0 0 80 80\" xmlns=\"http://www.w3.org/2000/svg\">";
	for (uint8_t i = 0; i < 8; i++) {
		for (uint8_t j = 0; j < 8; j++) {
			std::cout << "<rect x=\"" << i * 10 + 1 << "\" y=\""
				  << j * 10 + 1 << "\" width=\"8\" height=\"8\" "
				  << "fill=\"gray\"/>";
		}
	}
	uint8_t px = 0;
	uint8_t py = 0;
	for (auto [x, y] : history) {
		std::cout << "<line x1=\"" << px * 10 + 5 << ".5\" y1=\"" << py * 10 + 5 << ".5\" x2=\"" << x * 10 + 5 << ".5\" y2=\"" << y * 10 + 5 << ".5\" stroke=\"black\"/>";
		px = x; py = y;
	}

	std::cout << "</svg>";
}
